
Redmine - Feature #1077

ICS view of Calendar

2008-04-18 23:01 - Adam Knight

Status: New Start date: 2008-04-18

Priority: Normal Due date:  

Assignee:  % Done: 90%

Category: Feeds Estimated time: 0.00 hour

Target version:    

Resolution:    

Description

It would be really nice if we could get an ICS view of a project calendar similar to how we get RSS feeds of project activity.  This way

users can see all the events (and milestones/versions) in their calendar software and the activity in their RSS readers.

Related issues:

Has duplicate Redmine - Feature #1442: ICS generation Closed 2008-06-13

Has duplicate Redmine - Feature #6168: ical subscribtion for calendar Closed 2010-08-18

History

#1 - 2008-04-20 21:46 - Maxim Krušina

+1

#2 - 2008-04-22 02:35 - Stephanie Collett

+1

#3 - 2008-04-30 23:17 - Florian L

- File ICS_Support.patch added

- Status changed from New to Resolved

- Target version set to 0.7.1

- % Done changed from 0 to 100

This patch add the functionnality : "Also available in: iCal" !

I worked with the revision 1388.

This patch provide all the events from the beginning of the project till now.

Enjoy,

Florian

#4 - 2008-04-30 23:21 - Florian L

Its based on http://icalendar.rubyforge.org/

So you need to install iCalendar via GEM :

1. gem install icalendar

#5 - 2008-05-01 18:39 - Thomas Lecavelier

- Status changed from Resolved to 7

- % Done changed from 100 to 50

Florian,

Please correct these problems with your patch:

1. the patch don't mention the r1388, applying it will mess the merger

2. the file app/views/projects/calendar.rhtml is binary encoded instead of text

3. a minimal test harness should be a real plus for integrating this patch
#6 - 2008-05-02 20:25 - Jean-Philippe Lang

- Target version deleted (0.7.1)

#7 - 2008-05-05 19:35 - Florian L

- File ICS_Support__2.patch added

- % Done changed from 50 to 90

New version. Bugs fixed. Tested on two production version.

Any feedbacks ?

#8 - 2008-05-05 19:47 - Florian L

- Target version set to 0.8

#9 - 2008-06-05 11:34 - yann belot

Hi,

how can we use it ?

thx

#10 - 2008-08-08 11:58 - Daniel N

+1 Would be a very cool feature.

#11 - 2008-09-09 10:25 - Joris Verschoor

If I go to: http://xxxxxxx/projects/calendar/PROJECTNAME?format=ics I get a missing template error:

ActionController::MissingTemplate (Missing template common/calendar.ics.erb in view path xxxxx/redmine-0.7.3/a

pp/views):

#12 - 2008-11-05 10:16 - Jan Ivar Beddari

+1

Combining ICS-support with something like http://remotecalendars.sourceforge.net would be of great value in enterprise use cases. Remote access

would need to be secured somehow, does this patch already add some sort of password auth? Please excuse my limited knowledge here ..

#13 - 2008-11-11 10:39 - Jean-Philippe Lang

- Target version deleted (0.8)

#14 - 2008-11-24 10:22 - Mihail M

it`s work with 0.8 ?

#15 - 2008-11-24 22:42 - Florian L

I dont test it with 0.8. I'll work on it.

Joris Verschoor Verschoor :

Just create the file calendar.ics.erb in /app/views/common with this :

<%= @cal_string %>

#16 - 2008-11-26 05:17 - Myles Braithwaite

Could you also support issue exported as tasks?

#17 - 2009-04-27 13:55 - Jens Goldhammer

+1

#18 - 2009-06-19 17:08 - Frotran Def

+1

#19 - 2009-07-17 11:07 - Joan Ginard

+1
I cannot make ICS_Support__2.patch to work on 0.8.2.

Think feature is very very useful to get many peoples's calendar apps sincronized.

#20 - 2009-09-03 12:03 - Maxim Krušina

+1000 - can someone create plugin for this?

#21 - 2009-09-07 10:43 - Sławek Goszcz

- File ICS_Support__3.patch added

I've created a patch for version 0.8.4. I think it will be usefull.

#22 - 2009-09-07 22:54 - Maxim Krušina

Slavek> Great! ;) Please, is it possible to convert it to plugin? Patches and not so much fŕiendly with SVN update ...

#23 - 2009-09-29 12:16 - Mike Heininger

Would it be possible to add "key" authentication like with the RSS feeds?

#24 - 2009-09-30 21:38 - Pablo 09

+1

I have tried to apply path on trunk but i havent application.rb, i have application_controller.rb  How can i apply the path??

Thanks

#25 - 2009-11-23 21:55 - Frank Schwarz

- File ICS_Support__4.patch added

Patch adopted to current trunk

#26 - 2009-11-24 07:03 - Frank Schwarz

- File ICS_Support__5.patch added

There was one file missing in patch 4, so new patch 5.

#27 - 2009-12-08 15:20 - Nick Wilsdon

We've got a problem with this, using patch 5 and v. 0.8.7 redmine. Links are appearing ok on the issues page. Clicking in FF prompts to download

file. Google doesn't seem to like the URL or the file as a manual upload.

Error on manual upload:

Processed zero events

Failed to import events: unable to process your iCal/CSV file...

Looked at the file - seems ok but I don't know the format for iCal.

#28 - 2009-12-09 00:04 - Mischa The Evil

Nick Wilsdon wrote:

We've got a problem with this, using patch 5 and v. 0.8.7 redmine. [...]

 ICS_Support__5.patch is for source:/trunk only. Latest iteration of the patch for source:/branches/0.8-stable is ICS_Support__3.patch.

Please note that I haven't tested the patches myself...

#29 - 2010-02-02 23:23 - Fred M.

Hi,

Is there any plan to update the patch files for Redmine 0.9.1 ? It does not seem a big work to edit the patch, but I've absolutely no knowledge in

RoR...

Thanks in advance !
Fred.

#30 - 2010-02-04 17:10 - Erik-Jan Jaquet

Hi all,

I am running the current stable version of Redmine (0.8.7). I have changed the 3 files according to path #3, which should be working for the stable

release.

But when I reboot, nothing happens. I don't see any link to the ICS view? How do I apply this patch?

Kind regards,

Erik-Jan

#31 - 2010-02-06 16:11 - Fred M.

Hi,

I manually applied the patch v5 to my files and it's now working. I also updated the code to export items in the form of calendar tasks, and it's working

find.

I think it would be even better if it was possible to provide the task export in the issues list, at the same place than Atom/PDF/CSV links. This would

be very useful since it would enable to subscribe to custom issue list instead of all issues of the project. Again, I'd be glad to do it myself, but I have

actually no knowledge in ruby and even less  in Redmine design...

If anybody is interested by the patch for 0.9.1, please ask I would try to provide an SVN patch...

Thanks again,

Fred.

#32 - 2010-02-09 11:37 - Red Mind

Fred M. wrote:

If anybody is interested by the patch for 0.9.1, please ask I would try to provide an SVN patch...

 Hi,

I am interested by your patch.

Thanks

#33 - 2010-02-11 08:07 - David Bauer

Hi,

thanks for your work on that. I would also be interested in the SVN patch.

Thanks again,

David

#34 - 2010-02-11 11:07 - Maxim Krušina

Can someone create plugin or integrade it into trunk, please? ;)

#35 - 2010-02-27 12:14 - Xavier Moles Lopez

Sławek Goszcz wrote:

I've created a patch for version 0.8.4. I think it will be usefull.

 This patch didn't worked for me (with version 0.8.4 stable). Are there any prerequisite for this patch to work? Do I need to apply first patches 1 and 2?

Thanks for the good job you're doing!

Xavier

#36 - 2010-02-27 13:30 - Xavier Moles Lopez

This patch didn't worked for me (with version 0.8.4 stable). Are there any prerequisite for this patch to work? Do I need to apply first patches 1

and 2?

Thanks for the good job you're doing!

2025-07-02 4/9

https://www.redmine.org/issues/3


Xavier

 I found out that Sławek's patch do actually work! The confirmation on UBC Redmine page

Although the changes are not visible, the adress of the ics calendar is available and working...

#37 - 2010-03-02 16:03 - Maxim Krušina

Please, is it possible/simple to convert this functionality into plugin?

#38 - 2010-03-17 21:36 - Michael Hellein

I've almost finished turning this code into a plugin. I don't have enough time to finish now, but I hope to be able to provide something relatively soon.

#39 - 2010-04-15 10:45 - Carl Pef

Thanks for your work Michael !

Indeed, a plugin would be very nice :)

#40 - 2010-05-30 18:23 - y v

- File redmine-0.9-stable-roadmap-icalendar-ics-export.patch added

Hi,

I just wrote a patch which works with version 0.9 stable and does it a bit different than your approaches.

In my opinion we should focus on the roadmap and so exporting versions as events (VEVENT) and its issues as todos (VTODO). I used the  VPIM

gem and tested my integration with iCal on Mac OS X 10.6. With this patch you can:

Subscribe to a roadmap of a project or download it as static file

See its issues with priority and status

I added some screenshots for you (make sure that you deactivate the Remove ToDo options when subscribing to a calendar).

After uploading this stuff I'll fork the project on GitHub and apply those changes there.

#41 - 2010-05-30 18:24 - y v

- File redmine-roadmap.png added

- File ical-overview.png added

- File ical-subscription.png added

- File ical-todo.png added

- File ical-url.png added

- File redmine-roadmap-2.png added

#42 - 2010-06-05 14:51 - Fred M.

Hi,

Many thanks Yves for your patch, it is working very well and your approach is fine for me :)

However, you did not support sub-domains or secured protocol in your code. The workaround is quite simple : add the parameters

:only_path => false, :host => Setting.host_name

to every call of url_for and link_to methods.   Here are the updated occurences of these methods:

app/controllers/projects_controller.rb line 345:

event.url           url_for(:controller => 'versions', :action => 'show', :id => version, :only_path => 

false, :host => Setting.host_name)

app/controllers/projects_controller.rb line 355:

options.push Vpim::DirectoryInfo::Field.create('URL', url_for(:controller => 'issues', :action => 'show', 

:id => issue , :only_path => false, :host => Setting.host_name))
app/views/projects/roadmap.rhtml line 48:

<

%= link_to 'iCalendar', :controller => 'projects', :action => 'roadmap', :format => 'ics', :key => User.cu

rrent.rss_key, :only_path => false, :host => Setting.host_name, :protocol => 'webcal' %><br />

The link using the webcal protocol is not working for me since my Redmine server is only available through HTTPS, but anyway I just have to

subscribe to the ics file itself and it's working well.

Please note that the value inside Setting.host_name is the value set in the Administration section Settings. It should contain only the domain name

without the trailing slash, like https://redmine.mycompany.com.

Hope this would help :)

Regards,

Fred.

#43 - 2010-06-07 22:19 - y v

Hi Fred,

thanks for you reply. I added your changes to the GitHub repository

I left out the changes in app/views/projects/roadmap.rhtml because there's no SSL pendant for webcal-protocol (like e.g. ldaps for ldap). As far as I

know we currently would have to utilize CalDAV if we wanted to encrypt our calendar stuff over the wire…

To anyone who wants to use this changes - please refer to the GitHub repository if the patch above doesn't work for you.

#44 - 2010-09-20 14:35 - Daniel Schuba

duplicate here #6168

#45 - 2010-09-27 09:56 - Kasper Nielsen

Yves Vogl wrote:

Hi Fred,

thanks for you reply. I added your changes to the GitHub repository

I left out the changes in app/views/projects/roadmap.rhtml because there's no SSL pendant for webcal-protocol (like e.g. ldaps for ldap). As far

as I know we currently would have to utilize CalDAV if we wanted to encrypt our calendar stuff over the wire…

To anyone who wants to use this changes - please refer to the GitHub repository if the patch above doesn't work for you.

 Is someone still working on this? I get a "repository does not exist" when clicking the GitHub link.

#46 - 2010-10-04 23:09 - Frank Schwarz

Maxim Krušina wrote:

Please, is it possible/simple to convert this functionality into plugin?

 Here you are: http://code.google.com/p/redmics/

Feedback is welcome.

#47 - 2010-10-06 10:42 - Jan from Planio www.plan.io

I created a modified version which moves the links from the sidebar to "Also available in" links at the bottom of the calendar. For me, This feels more

"natural", as the Atom, CSV, PDF links are there on the issues view as well. This needs a new hook however, which I've requested in #6586.

Feedback welcome.

#48 - 2010-10-06 20:27 - H W

Just wanted to give feedback that Frank Schwarz' plugin works very well for me, thanks Frank.

#49 - 2010-10-14 13:48 - Maxim Krušina

Frank Schwarz wrote:
Maxim Krušina wrote:

Please, is it possible/simple to convert this functionality into plugin?

 Here you are: http://code.google.com/p/redmics/

Feedback is welcome.

 Hi Frank, thank you very much for your work! We finally won the battle with our selfrestarting serrver, so now we upgrade our redmine server and we

start big testing! Thank you!

#50 - 2010-10-14 14:21 - Terence Mill

The plugin is working here, but we don't like that ist defining its "own" filters statically. We would like to have an ics export of the tickets of cuurent the

view (with selected filters) instead, like the csv or pdf export works.

#51 - 2010-10-14 14:54 - Felix Schäfer

Terence Mill wrote:

The plugin is working here, but we don't like that ist defining its "own" filters statically. We would like to have an ics export of the tickets of

cuurent the view (with selected filters) instead, like the csv or pdf export works.

 I have a fork of the plugin in the works to provide the calendar view as an ical, and you can use custom queries on calendar (though the UI for that

isn't in place just yet IIRC). I'll drop a short note once I have something to show.

#52 - 2010-10-14 17:46 - Frank Schwarz

Terence Mill wrote:

The plugin is working here, but we don't like that ist defining its "own" filters statically. We would like to have an ics export of the tickets of

cuurent the view (with selected filters) instead, like the csv or pdf export works.

 I also was pondering this option. However, the filter for the csv export is stored in the web session. So you have to export and save your ICS file

somewhere before you can subscribe it (offline). An online subscription with a stable filter is IMHO not possible. - I am happy to be proven wrong on

this.

#53 - 2010-10-22 03:36 - Roger Casaliñas

+1

#54 - 2010-10-28 13:20 - Anonymous

Hi, i can´t get the plugin to work. The links appear in the sidebar but when i click on them a 500 Internal Server Error occurs.

My URL reads 

http://web:3000/i_calendar?assigned_to=%2B&format=atom&key=8e459bfe92bdfae7b18bf3288cb1d4b0f7faeac0&project_id=print&status=all

As you can see i am runnning an own virtual host on port 3000.

Here is my apache2 config:

Listen 3000

<VirtualHost *:3000>

ServerName redmine.example.com

ServerAlias redmine

ServerAdmin webmaster@localhost

DocumentRoot /var/www/redmine/public/

<IfModule mod_fcgid.c>

DefaultInitEnv RAILS_ENV production

DefaultInitEnv GEM_HOME /var/local/lib/gems

DefaultInitEnv RUBYLIB /usr/local/ruby/lib/

</IfModule>

<Directory /var/www/redmine/public/>

Options Indexes ExecCGI FollowSymLinks

Order allow,deny

Allow from all

AllowOverride all

</Directory>

RailsBaseURI /

ErrorLog /var/log/apache2/redmine_error.log

LogLevel info

CustomLog /var/log/apache2/redmine_access.log combined

</VirtualHost>  

2025-07-02 7/9

http://code.google.com/p/redmics/
http://web:3000/i_calendar?assigned_to=%2B&format=atom&key=8e459bfe92bdfae7b18bf3288cb1d4b0f7faeac0&project_id=print&status=all


i ain´t got a .htacces file (the one that came with redmine) in my public directory because when i had it enabled my static files like css and javascripts

weren´t found.

Can anybody tell me how to get the ICS links to work? Thank you in advance.

#55 - 2010-10-28 13:22 - Anonymous

I forgot: I followed the instructions on this page: http://code.google.com/p/redmics/

#56 - 2010-10-28 18:04 - Frank Schwarz

Please file a bug at http://code.google.com/p/redmics/issues/list and provide me with the relevant portions of /var/log/apache2/redmine_error.log and

REDMINE_HOME/log/production.log and the version number of the plug-in.

I guess it is an NPE somewhere.

Ace Man wrote:

Hi, i can´t get the plugin to work. The links appear in the sidebar but when i click on them a 500 Internal Server Error occurs.

#57 - 2010-12-21 19:36 - Luis Alvarez

Ace Man,

Make sure you have the perquisite icalender plugin installed:

see http://code.google.com/p/redmics/

#58 - 2010-12-21 20:08 - Luis Alvarez

Hi, Got it to work. Where is the subscription url provided? I've seen several images but I don't see any format provided.

#59 - 2011-01-04 21:16 - Luis Alvarez

Format for subscription:

eg:

webcal://<theredmineurl>/redmine/i_calendar?assigned_to=%2A&format=atom&key=765561bf6551aawwa6351333206aad58d9f95bd114&project_id

=theproject&status=all

#60 - 2011-01-04 21:21 - Luis Alvarez

Luis Alvarez wrote:

To get the subscription link to the redmine calendar

 Under ICalendar right click on the appropriate link and copy link location.

replace http:// with webcal://

eg:

webcal://theprojectsite.com/redmine/i_calendar?assigned_to=%2A&format=atom&key=765561bf6551aawwa6351333206aad58d9f95bd114&pro

ject_id=theproject&status=all

#61 - 2011-01-14 13:21 - Andy Mahieu

In Outlook 2010, the ICalendar works.

But in Outlook 2003, it doesn't. Outlook 2003 expects to see "METHOD:PUBLISH" in the beginning of the file.

#62 - 2011-01-27 00:34 - Fred M.

Frank Schwarz wrote:

Maxim Krušina wrote:

Please, is it possible/simple to convert this functionality into plugin?

 Here you are: http://code.google.com/p/redmics/
Feedback is welcome.

 Hi Franck, thank you very much for your great work on this plugin. It is working fine for me. It could be worth to mention in your documentation that

you need to enable the "Calendar" module in the project's configuration (it is not that obvious when you only use the issues and expect to see the

iCalendar links).

Again, due to my HTTPS server configuration, I have to use the https:// URL instead of replacing it with webcal://

I'm a little bit disappointed because I'm not using start/end dates inside Redmine. So as it is today, I can't get much benefit from this plug-in since the

calendar is always empty...

I'll post a feature request in Google code to include the Tasks export in your ICS file, that would be a great feature making your plugin a perfect

companion for redmine :)

Thanks again,

Fred.

#63 - 2013-01-13 21:04 - Jean-Philippe Lang

- Status changed from 7 to New

Assigned issue with no assignee back to New status.

#64 - 2013-03-19 21:03 - Frank Schwarz

For the record: the redmics plugin is now hosted on GitHub: https://github.com/buschmais/redmics. Happy forking!

#65 - 2016-03-30 21:34 - Al Pocheche

Anything like that for redmine 3.x?

Redmine version                3.2.1.stable

Ruby version                   2.1.8-p440 (2015-12-16) [x86_64-linux]

Rails version                  4.2.5.2

Environment                    production

Database adapter               Mysql2

#66 - 2016-03-30 22:57 - Al Pocheche

Done! I installed this one https://github.com/buschmais/redmics and working fine. Thanks any way.

#67 - 2017-12-01 09:30 - Manuel Doll

Al Pocheche wrote:

Done! I installed this one https://github.com/buschmais/redmics and working fine. Thanks any way.

 Does not work with 3.4.2 anymore. 404-Error when trying to access Tickets after installing the plugin. Does anyone have an idea why? Many thanks.

#68 - 2018-11-16 21:01 - Ken Gold

Has anyone looked at this recently? I would like to get this going on 3.4.2 again and maybe into main release after 4.0...

Files

ICS_Support.patch 6.72 KB 2008-04-30 Florian L

ICS_Support__2.patch 3.75 KB 2008-05-05 Florian L

ICS_Support__3.patch 3.05 KB 2009-09-07 Sławek Goszcz

ICS_Support__4.patch 4.5 KB 2009-11-23 Frank Schwarz

ICS_Support__5.patch 4.74 KB 2009-11-24 Frank Schwarz

redmine-0.9-stable-roadmap-icalendar-ics-export.patch 5.8 KB 2010-05-30 y v

redmine-roadmap.png 187 KB 2010-05-30 y v
